'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';
import { buildIbansAddSchema } from './schema';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const validatedBody = buildIbansAddSchema.parse(body);
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            mutation CreateBuildIban($input: CreateBuildIbanInput!) {
                createBuildIban(input: $input) {
                    _id
                    uuid
                    createdAt
                    updatedAt
                    expiryEnds
                    expiryStarts
                }
            }
        `;
        const variables = { input: validatedBody };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.createBuildIban, status: 200 });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
